import UIKit

@dynamicMemberLookup
public struct UniversalObject {
    private var dict = [String: Any]()

    public subscript(dynamicMember member: String) -> Any? {
        get {
            return dict[member]
        }
        set {
            dict[member] = member
        }
    }

    public subscript<T>(dynamicMember member: String) -> T {
        return dict[member] as! T
    }
}

func test() {
    var x = UniversalObject()
    x.foo = 5
    x.bar = 100
    x.🖖 = 42

    dump(x)

    let y: Int = x.foo ?? 0
    let a: Int = x.bar
}
































































